package game;
import java.awt.*;

public class Lines
{
    private static final int sprMax = 18;
    private static final int sprSize = 20;

    private Sprite sprite[] = new Sprite[sprMax+1];

    public void setSprites(Ground grnd)
    {
        int i, r, g, b;
        Number num = new Number();

        for ( i=0; i<= sprMax; i++ )
        {
            Number red = new Number(i*5);
            Number green = new Number(i*20);
            Number blue = new Number(i*28);

            sprite[i] = new Sprite
            (
                (int) 5+i*2, (int) 5+i*2,
                red.reduceToLimit(255),
                green.reduceToLimit(255),
                blue.reduceToLimit(255) 
            );

            sprite[i].randPos( grnd.getBottom(), grnd.getRight() );
        }

    }

    public Point calcPosSpr(Ground grnd, int mouseX, int mouseY, boolean followMouse)
    {
        int i;
        Point all = new Point(0,0);
        Point med = new Point();
        double targX, targY;

        for ( i=0; i<=sprMax; i++ )
        {
            if ( i<sprMax )
            {
                targX = sprite[i+1].x;
                targY = sprite[i+1].y;
            }
            else
            {
                if ( followMouse )
                {
                    targX = mouseX - grnd.getOffsetX();
                    targY = mouseY - grnd.getOffsetY();
                }
                else
                {
                    targX = sprite[0].x;
                    targY = sprite[0].y;
                }
            }

            sprite[i].follow( (int) targX, (int) targY );

            sprite[i].move(grnd);
            sprite[i].bounce(grnd);

            all.setX( all.getX() + sprite[i].x );
            all.setY( all.getY() + sprite[i].y );
        }

        med.setX( all.getX() / (sprMax+1) );
        med.setY( all.getY() / (sprMax+1) );

        return med;
    }

    public void spritesAppear(Graphics graph, Ground grnd, Point med)
    {
        int i;
        Point brother = new Point();
        int pX[] = new int[3];
        int pY[] = new int[3];

        for ( i=0; i<=sprMax; i++ )
        {
            if ( i<sprMax )
                brother = sprite[i+1].getPoint();
            else
                brother = sprite[0].getPoint();

            pX[0] = (int) sprite[i].x + grnd.getOffsetX();
            pY[0] = (int) sprite[i].y + grnd.getOffsetY();

            pX[1] = (int) brother.getX() + grnd.getOffsetX();
            pY[1] = (int) brother.getY() + grnd.getOffsetY();

            pX[2] = (int) med.getX();
            pY[2] = (int) med.getY();

            graph.setColor ( new Color(0,90+i*4,40+i*10) );

            graph.fillPolygon( pX, pY, 3 );

        }
    }

}
